﻿
Public Class RouteData
   Public Start As Way
   Public ReadOnly LayerSource As New Dictionary(Of String, List(Of Address))
   Public ReadOnly Layers As New Dictionary(Of String, List(Of Address))
   Public ReadOnly Request As New Queue(Of String)
   Public ReadOnly RequestSource As New List(Of String)
   Public ReadOnly Routes As New List(Of Way)
   Public Property RouteLimit As Integer = 20
   Public Property AddressLimitPerLayer As Integer = 10

   Public Sub Reset()
      Routes.Clear()
      Request.Clear()
      RequestSource.ForEach(AddressOf Request.Enqueue)
      LayerSource.ForEach(Sub(l) Layers(l.Key).ReplaceBy(l.Value))
      Start = Way.From(Layers(Request.Dequeue)(0), 0)
      Routes.Add(Start)
   End Sub

End Class
