﻿Public Class WayEnumerable : Inherits Enumerable(Of Way)
   Private _Curr, _W As Way
   Private _Starts As Boolean = True
   Public Sub New(ByVal w As Way)
      _W = w
   End Sub
   Protected Overrides Function TryMovenext(ByRef Current As Way) As Boolean
      If _Starts Then
         _Curr = _W
         _Starts = False
      ElseIf _Curr.Null OrElse _W Is _Curr Then
         Return False
      End If
      Current = _Curr
      _Curr = _Curr.Next
      Return True
   End Function
   Protected Overrides Sub CleanUp()
      _Starts = True
      MyBase.CleanUp()
   End Sub
End Class
