﻿Imports System.Collections.Generic
Imports System.Runtime.CompilerServices

Namespace System
   Public Module DelegateX

      <Extension()> _
      Public Sub [Handles](ByVal inPin As Action, ByRef outPin As Action)
         outPin = DirectCast([Delegate].Combine(outPin, inPin), Action)
      End Sub

      <Extension()> _
      Public Sub [Handles](Of T)(ByVal inPin As Action(Of T), ByRef outPin As Action(Of T))
         outPin = DirectCast([Delegate].Combine(outPin, inPin), Action(Of T))
      End Sub

      <Extension()> _
      Public Sub [Handles](Of T1, T2)(ByVal inPin As Action(Of T1, T2), ByRef outPin As Action(Of T1, T2))
         outPin = DirectCast([Delegate].Combine(outPin, inPin), Action(Of T1, T2))
      End Sub

      <Extension()> _
      Public Sub [Handles](Of T)(ByVal inPin As Func(Of T), ByRef outPin As Func(Of T))
         outPin = DirectCast([Delegate].Combine(outPin, inPin), Func(Of T))
      End Sub

      <Extension()> _
      Public Sub [Handles](Of T1, T2)(ByVal inPin As Func(Of T1, T2), ByRef outPin As Func(Of T1, T2))
         outPin = DirectCast([Delegate].Combine(outPin, inPin), Func(Of T1, T2))
      End Sub

      <Obsolete("use Handles-Extension")>
      <Extension()> _
      Public Function CombineWith(ByVal subj As Action, ByVal obj As Action) As Action
         Return DirectCast([Delegate].Combine(subj, obj), Action)
      End Function

      <Obsolete("use Handles-Extension")>
      <Extension()> _
      Public Function CombineWith(Of T)(ByVal subj As Action(Of T), ByVal obj As Action(Of T)) As Action(Of T)
         Return DirectCast([Delegate].Combine(subj, obj), Action(Of T))
      End Function

      <Obsolete("use Handles-Extension")>
      <Extension()> _
      Public Function CombineWith(Of T)(ByVal subj As Func(Of T), ByVal obj As Func(Of T)) As Func(Of T)
         Return DirectCast([Delegate].Combine(subj, obj), Func(Of T))
      End Function

      <Obsolete("use Handles-Extension")>
      <Extension()> _
      Public Function CombineWith(Of T1, T2)(ByVal subj As Func(Of T1, T2), ByVal obj As Func(Of T1, T2)) As Func(Of T1, T2)
         Return DirectCast([Delegate].Combine(subj, obj), Func(Of T1, T2))
      End Function
   End Module
End Namespace
