﻿Imports System.IO
Imports System.Text

Public Class Program

   Public Shared RoutData As New RouteData

   <STAThread()> _
   Public Shared Sub Main(ByVal commandLineArgs As String())
      If commandLineArgs.Length = 3 Then
         ExecuteCommand(commandLineArgs)
         Return
      End If
      Application.EnableVisualStyles()
      Application.SetCompatibleTextRenderingDefault(False)
      Dim loader = New DataLoader
      Dim finder = New RouteFinder
      Dim reducer = New LayerReducer
      Dim frm = New frmBaerSucht
      finder.NextStep.Handles(frm.NextStep)
      finder.FindComplete.Handles(frm.FindComplete)
      frm.FindDone.Handles(finder.FindDone)
      loader.LoadData.Handles(frm.LoadData)
      reducer.Reduce.Handles(frm.ReduceLayer)
      Application.Run(frm)
      My.Settings.Save()
   End Sub

   Private Shared Sub ExecuteCommand(ByVal commandLineArgs As String())
      Dim loader = New DataLoader
      Dim finder = New RouteFinder
      Dim reducer = New LayerReducer
        loader.LoadData(commandLineArgs(0), commandLineArgs(1))

        Dim sw = System.Diagnostics.Stopwatch.StartNew

        finder.FindComplete.Invoke()
        sw.Stop()
        Dim length = Program.RoutData.Routes(0).Length.ToString()
      Dim names = From stat In Program.RoutData.Routes(0).Stations Select stat.Address.Name
        My.Computer.FileSystem.WriteAllText(commandLineArgs(2), String.Join(" -> ", names) & NewLine & NewLine & length & NewLine & NewLine & sw.ElapsedMilliseconds.ToString(), False)
   End Sub


End Class
