﻿Public Class WayInfo
   Public Way As Way
   Public Property X As Single
   Public Property Y As Single
   Public Property Location As String

   Public Sub New(ByVal w As Way)
      Way = w
      Location = String.Format("{0:N1}/{1:N1}", w.Address.Point.X, w.Address.Point.Y)
   End Sub
   Public ReadOnly Property Typ As String
      Get
         Return Way.Address.Typ
      End Get
   End Property
   Public ReadOnly Property Name As String
      Get
         Return Way.Address.Name
      End Get
   End Property
   Public ReadOnly Property ID As Integer
      Get
         Return Way.Address.ID
      End Get
   End Property
   Public ReadOnly Property Length As Double
      Get
         Return Way.Length
      End Get
   End Property
End Class
Public Class RouteInfo
   Public Property ID As Integer
   Public Property Ways As New List(Of WayInfo)
   Public ReadOnly Property Length As Double
      Get
         Return If(Ways.Count = 0, 0, Ways(0).Length)
      End Get
   End Property
   Public ReadOnly Property Triviality As Integer
      Get
         Return If(Ways.Count = 0, 0, Ways(0).Way.Triviality)
      End Get
   End Property
End Class